var Twitter = {
	// config
  version: '2.6',
  refresh: 5 * 60 * 1000, // 5 min

	// members
  currentId: 0,
  currentApi: null,

  initialize: function() {
	  // window size
	  var width = Cookie.getValue('width') || 400;
	  var height = Cookie.getValue('height') || 600;
	  window.resizeTo(width, height);

	  // calcurate the width of titlebar, borders
	  $(function() {
		  var $b = $(document.body);
		  Twitter.border = {
			width: width - $b.width(),
			height: height - $b.height()
		  };
		  document.title += ' ver.' + Twitter.version;
	  });

	  // onresize, save the size of window
	  $(window).resize(function() {
		  if (document && document.body) {
			  var $b = $(document.body);
			  Cookie.setValue('width', $b.width() + Twitter.border.width, 10);
			  Cookie.setValue('height', $b.height() + Twitter.border.height, 10);
		  }
	  });
  },


	//
  showLoginPanel: function() {
	  $('#loginpanel').slideDown(function() {
		  $('#username').focus();
	  });
  },

	//
  closeLoginPanel: function() {
	  $('#username, #password').val('');
	  $('#loginpanel').slideUp(function() {
		  $('#statusArea').focus();
	  });
  },

	// submit of loginpanel
  login: function() {
	  var user = $('#username').val();
	  var pass = $('#password').val();
	  Cookie.setValue('user', user, 10);
	  Cookie.setValue('password', pass, 10);
	  Twitter.userName = user;
	  Twitter.password = pass;
	  if (user && pass) {
		  Twitter.friendsTimeline();
		  Twitter.closeLoginPanel();
	  }
  },


  friendsTimeline: function(page) {
	  Twitter._timeline('friends_timeline.json', page, true);
	  $('#tabs a').removeClass('selected');
	  $('#friendsTab').addClass('selected');
  },

  publicTimeline: function(page) {
	  Twitter._timeline('public_timeline.json', page, true);
	  $('#tabs a').removeClass('selected');
	  $('#publicTab').addClass('selected');
  },

  userTimeline: function(page) {
	  Twitter._timeline('user_timeline.json', page, true);
	  $('#tabs a').removeClass('selected');
	  $('#userTab').addClass('selected');
  },


	// make url string from cookie, or show loginpanel
  _makeUrl: function(pathend) {
	  var user = Twitter.userName || Cookie.getValue('user') || '';
	  var pass = Twitter.password || Cookie.getValue('password') || '';
	  if (user == '' || pass == '') {
		  Twitter.showLoginPanel();
		  return null;
	  } else {
		  Twitter.userName = user;
		  Twitter.password = pass;
		  var url = 'https://twitter.com/statuses/' + pathend;
		  return url;
	  }
  },

	// submission of "send"
  update: function() {
	  var input = $('#statusArea');
	  var url = Twitter._makeUrl('update.json');
	  if (url && input.val()) {
		  $.ajax({
			username : Twitter.userName,
			password : Twitter.password,
			url      : url,
			type     : 'POST',
			dataType : 'json',
			async    : true,
			data     : {
			  status: input.val()
			},
			success: function() {
				input.val('');
				Twitter.friendsTimeline();
			},
			error: function(xml, status, e) {
				Twitter._showErrorMessage(this, xml, status, e);
			}
		  });
	  }
  },

	// load timeline
  _timeline: function(api, page, force) {
	  page = (!page || page < 1) ? 1 : page;
	  var url = Twitter._makeUrl(api);
	  if (!url) {
		  return;
	  }
	  var sinceStr = (new Date((new Date).getTime() - 24 * 3600 * 1000)).toGMTString()
		$.ajax({
		  username : Twitter.userName,
		  password : Twitter.password,
		  type     : 'GET',
		  dataType : 'json',
		  url      : url,
		  async    : true,
		  data     : {
			since: sinceStr,
			page: page
		  },
		  success: function(result) {
			  if (result.length > 0) {
				  if ((page != 1
					   || api != Twitter.currentApi
					   || result[0].id != Twitter.currentId)
					  || force) {
					  // show result
					  Twitter._refresh(api, page, result);
					  Twitter.currentApi = api;
					  if (page == 1) {
						  Twitter.currentId = result[0].id;
					  }
				  }
			  }

			  // reserve next loading
			  if (Twitter.timer) {
				  clearTimeout(Twitter.timer);
			  }
			  Twitter.timer = setTimeout(function() {
				  Twitter._timeline(api)
				}, Twitter.refresh);
		  },
		  error: function(xml, status, e) {
			  Twitter._showErrorMessage(this, xml, status, e);
		  }
		});
	  $('#statusArea').focus();
  },

  _showErrorMessage: function(ajax, xml, status, e) {
	  $('#errortitle').text(e && e.description || 'G[܂');
	  var cont =  $('#errorcontents');
	  if (xml.responseText) {
		  var eh  = xml.responseText.replace(/^[\s\S]*<body>([\s\S]*)<\/body>[\s\S]*$/m, '$1');
		  cont.html(eh);
	  } else {
		  cont.html(DebugInspector.inspect(e));
	  }
	  $('#errormessage').slideDown();
	  $('img', cont).each(function() {
		  this.src = this.src.replace(/.+(\/images\/.+)/, 'https://twitter.com$1');
	  });
	  $('a', cont).each(function() {
		  this.href = this.href.replace(/file:\/\/[^:]+:(\/.*)/, 'https://twitter.com$1');
		  $(this).click(Twitter._openWithAssociation);
	  });
  },

	//
  _refresh: function(api, page, result) {
	  var area = $('#timeline');
	  var html = [];
	  for (var i = 0, len = result.length; i < len; i++) {
		  html.push(Twitter._createStatusHTML(result[i]));
	  }
	  area.html(html.join(''));

	  // pager
	  var pager = $('<div id="pager"></div>');
	  if (page > 1) {
		  var newer = $('<a href="#" tabindex="-1" style="float:left"> newer</a>');
		  newer.click(function() {
			  Twitter._timeline(api, page - 1, true);
		  });
		  pager.append(newer);
	  }
	  var older = $('<a href="#" tabindex="-1" style="float:right">older </a>');
	  older.click(function() {
		  Twitter._timeline(api, page + 1, true);
	  });
	  pager.append(older);
	  area.append(pager);

	  // open event with association
	  $('a.open', area).click(Twitter._openWithAssociation);

	  // scroll
	  area[0].scrollTop = 0;
  },

	// make div html
  _createStatusHTML: function(s) {
	  return html = [
		  '<div class="status', s.text.indexOf('@' + Twitter.userName) >= 0 ? ' tome' : '', '">',
		  '  <img src="', s.user.profile_image_url, '" alt="', s.user.name, '(', s.user.screen_name, ')" />',
		  '  <span class="suser" title="', s.user.name, '">',
		  '    <a class="open" href="https://twitter.com/', s.user.screen_name, '">', s.user.screen_name, '</a>',
		  '  </span>',
		  '  <span class="stext">',
		  s.text.replace(/(https?:\/\/[-_.!~*\'()\w;\/?:\@&=+\$,%#]+)/g, '<a class="open" href="$1">$1</a>')
		  .replace(/(@(\w+))/g, '<a class="open" href="https://twitter.com/$2">$1</a>'),
		  '  </span>',
		  '</div>'
		  ].join('\n');
  },

	// open url with associated application
  _openWithAssociation: function(evt) {
	  evt.preventDefault();
	  var shell = new ActiveXObject('Shell.Application');
	  shell.ShellExecute(this.href);
	  return false;
  }
};

// cookie utility
var Cookie = {
  setValue: function(name, value, days){
	  $.cookie(name, value, { path: '/', expires: days });
  },

  getValue: function(name) {
	  return $.cookie(name);
  }
};

var ChildWindow = {
  show: function(url, name, width, height, additionalStates) {
	  function makeStateString(obj, obj2) {
		  var ar = [];
		  for (var key in obj) {
			  ar.push(key + '=' + obj[key]);
		  }
		  if (obj2) {
			  for (var key in obj2) {
				  ar.push(key + '=' + obj2[key]);
			  }
		  }
		  return ar.join(',');
	  }
	  var sw = screen.availWidth;
	  var sh = screen.availHeight;
	  if (height < 0) {
		  height = sh;
	  }
	  if (width < 0) {
		  width = sw;
	  }

	  var top = Math.floor((sh - height) / 2);
	  var left = Math.floor((sw - width) / 2);
	  var state = {
		location: 'no',
		width: width,
		height: height,
		left: left,
		top: top
	  };
	  return window.open(url, name, makeStateString(state, additionalStates));
  }
};

// fobOp
var DebugInspector = {
  showWindow: function(obj, limitDepth) {
	  var w = ChildWindow.show('', '_blank', 600, 700, {
		resizable: 'yes',
		scrollbars: 'no'
	  });

	  w.document.open();
	  w.document.write([
		  '<html>',
		  '  <head>',
		  '    <meta http-equiv="Content-Type" content="text/html;charset=Windows-31J">',
		  '    <title>Debug</title>',
		  '  </head>',
		  '  <body style="margin:0;padding:0;height:100%">',
		  '    <textarea id="t" style="width:100%;height:100%"></textarea>',
		  '  </body>',
		  '</html>'
		  ].join('\n'));
	  w.document.close();
	  w.document.getElementById('t').value = DebugInspector.inspect(obj, limitDepth);
  },

  alert: function(obj, limitDepth) {
	  alert(DebugInspector.inspect(obj, limitDepth));
  },

	/* IuWFNg̗vfċAIɂǂĕɂB */
	/* @param obj čΏۃIuWFNg                    */
	/* @param limitDepth \ǂ[̐           */
	/* @param depth iŎg                          */
	/* @param already iŎgj                      */
  inspect: function(obj, limitDepth, depth, already) {
	  depth      = depth      || 0;
	  limitDepth = limitDepth || 3;
	  already    = already    || [];
	  for (var i = 0, len = already.length; i < len; i++) {
		  if (already[i] === obj) {
			  return 'already';
		  }
	  }
	  if (obj === null) {
		  return 'null';
	  } else if (typeof obj === 'number'
				 || typeof obj === 'string'
				 || typeof obj === 'boolean'
				 || typeof obj === 'date') {
		  return (obj.toString()).replace('<', '&lt;').replace('>', '&gt;');
	  } else if (typeof obj === 'function') {
		  return '(function)';
	  } else if (typeof obj === 'object') {
		  if (depth > limitDepth) {
			  return 'too deep';
		  } else {
			  if (obj.outerHTML && obj.tagName) {
				  return 'HTMLObject &lt;' + obj.tagName + ' id="' + obj.id + '"&gt;';
			  } else {
				  already.push(obj);

				  var indent = '';
				  for (var i = 0; i < depth; i++) {
					  indent += '    ';
				  }
				  if (Array.prototype.isPrototypeOf(obj)) {
					  var html = ['[\n'];
					  for (var i = 0, len = obj.length; i < len; i++) {
						  html.push(indent + '    ');
						  try {
							  html.push(DebugInspector.inspect(obj[i], limitDepth, depth + 1, already));
						  } catch (e) {
							  html.push(e);
						  }
						  html.push('\n');
					  }
					  html.push(indent + ']');
					  return html.join('');
				  } else {
					  var html = ['{\n'];
					  for (var key in obj) {
						  html.push(indent + '    ');
						  html.push(key);
						  html.push(' : ');
						  try {
							  html.push(DebugInspector.inspect(obj[key], limitDepth, depth + 1, already));
						  } catch (e) {
							  html.push(e);
						  }
						  html.push('\n');
					  }
					  html.push(indent + '}');
					  return html.join('');
				  }
			  }
		  }
	  }
  }
}

Twitter.initialize();
$(function() {
	Twitter.friendsTimeline()
  });
